(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun init_diff_~Blen () Int)
(declare-fun honda_diff_~Blen () Int)
(declare-fun ray_diff_~Blen () Int)
(declare-fun init_diff_~j~3 () Int)
(declare-fun honda_diff_~j~3 () Int)
(declare-fun ray_diff_~j~3 () Int)
(declare-fun init_diff_~B.offset () Int)
(declare-fun honda_diff_~B.offset () Int)
(declare-fun ray_diff_~B.offset () Int)
(declare-fun |init_diff_#in~D.base| () Int)
(declare-fun |honda_diff_#in~D.base| () Int)
(declare-fun |ray_diff_#in~D.base| () Int)
(declare-fun |init_diff_#in~A.offset| () Int)
(declare-fun |honda_diff_#in~A.offset| () Int)
(declare-fun |ray_diff_#in~A.offset| () Int)
(declare-fun |init_diff_#in~Alen| () Int)
(declare-fun |honda_diff_#in~Alen| () Int)
(declare-fun |ray_diff_#in~Alen| () Int)
(declare-fun init_diff_~Alen () Int)
(declare-fun honda_diff_~Alen () Int)
(declare-fun ray_diff_~Alen () Int)
(declare-fun init_diff_~l1~2 () Int)
(declare-fun honda_diff_~l1~2 () Int)
(declare-fun ray_diff_~l1~2 () Int)
(declare-fun init_diff_~D.offset () Int)
(declare-fun honda_diff_~D.offset () Int)
(declare-fun ray_diff_~D.offset () Int)
(declare-fun |init_diff_#in~B.base| () Int)
(declare-fun |honda_diff_#in~B.base| () Int)
(declare-fun |ray_diff_#in~B.base| () Int)
(declare-fun init_diff_~found~2 () Int)
(declare-fun honda_diff_~found~2 () Int)
(declare-fun ray_diff_~found~2 () Int)
(declare-fun init_diff_~i~2 () Int)
(declare-fun honda_diff_~i~2 () Int)
(declare-fun ray_diff_~i~2 () Int)
(declare-fun
  |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
  () Int)
(declare-fun
  |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
  () Int)
(declare-fun
  |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
  () Int)
(declare-fun init_diff_~B.base () Int)
(declare-fun honda_diff_~B.base () Int)
(declare-fun ray_diff_~B.base () Int)
(declare-fun init_diff_~A.base () Int)
(declare-fun honda_diff_~A.base () Int)
(declare-fun ray_diff_~A.base () Int)
(declare-fun |init_diff_#in~Blen| () Int)
(declare-fun |honda_diff_#in~Blen| () Int)
(declare-fun |ray_diff_#in~Blen| () Int)
(declare-fun |init_diff_#in~B.offset| () Int)
(declare-fun |honda_diff_#in~B.offset| () Int)
(declare-fun |ray_diff_#in~B.offset| () Int)
(declare-fun |init_(select #length diff_~B.base)| () Int)
(declare-fun |honda_(select #length diff_~B.base)| () Int)
(declare-fun |ray_(select #length diff_~B.base)| () Int)
(declare-fun init_diff_~D.base () Int)
(declare-fun honda_diff_~D.base () Int)
(declare-fun ray_diff_~D.base () Int)
(declare-fun
  |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
  () Int)
(declare-fun
  |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
  () Int)
(declare-fun
  |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
  () Int)
(declare-fun |init_diff_#t~post2| () Int)
(declare-fun |honda_diff_#t~post2| () Int)
(declare-fun |ray_diff_#t~post2| () Int)
(declare-fun |init_diff_#t~mem0| () Int)
(declare-fun |honda_diff_#t~mem0| () Int)
(declare-fun |ray_diff_#t~mem0| () Int)
(declare-fun |init_diff_#in~A.base| () Int)
(declare-fun |honda_diff_#in~A.base| () Int)
(declare-fun |ray_diff_#in~A.base| () Int)
(declare-fun |init_diff_#in~D.offset| () Int)
(declare-fun |honda_diff_#in~D.offset| () Int)
(declare-fun |ray_diff_#in~D.offset| () Int)
(declare-fun init_diff_~l2~2 () Int)
(declare-fun honda_diff_~l2~2 () Int)
(declare-fun ray_diff_~l2~2 () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_(ite (select #valid diff_~A.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid diff_~A.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid diff_~A.base) 1 0)| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_(select #length diff_~A.base)| () Int)
(declare-fun |honda_(select #length diff_~A.base)| () Int)
(declare-fun |ray_(select #length diff_~A.base)| () Int)
(declare-fun |init_(ite (select #valid diff_~B.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid diff_~B.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid diff_~B.base) 1 0)| () Int)
(declare-fun |init_diff_#t~mem1| () Int)
(declare-fun |honda_diff_#t~mem1| () Int)
(declare-fun |ray_diff_#t~mem1| () Int)
(declare-fun |init_diff_#t~post6| () Int)
(declare-fun |honda_diff_#t~post6| () Int)
(declare-fun |ray_diff_#t~post6| () Int)
(declare-fun init_diff_~A.offset () Int)
(declare-fun honda_diff_~A.offset () Int)
(declare-fun ray_diff_~A.offset () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun init_diff_~k~2 () Int)
(declare-fun honda_diff_~k~2 () Int)
(declare-fun ray_diff_~k~2 () Int)
(declare-fun
  |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
  () Int)
(declare-fun
  |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
  () Int)
(declare-fun |honda_(ite (select #valid diff_#in~B.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid diff_#in~B.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid diff_#in~D.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid diff_#in~D.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| () Int)
(declare-fun |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) diff_#in~A.base)| () Int)
(declare-fun |ray_(select old(#length) diff_#in~A.base)| () Int)
(declare-fun |honda_(ite (select #valid diff_#in~A.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid diff_#in~A.base) 1 0)| () Int)
(declare-fun |honda_(select old(#length) diff_#in~B.base)| () Int)
(declare-fun |ray_(select old(#length) diff_#in~B.base)| () Int)
(declare-fun |honda_(select #length diff_#in~B.base)| () Int)
(declare-fun |ray_(select #length diff_#in~B.base)| () Int)
(declare-fun |honda_(select #length diff_#in~A.base)| () Int)
(declare-fun |ray_(select #length diff_#in~A.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
  () Int)
(declare-fun |honda_(select #length diff_#in~D.base)| () Int)
(declare-fun |ray_(select #length diff_#in~D.base)| () Int)
(declare-fun |honda_(select old(#length) diff_#in~D.base)| () Int)
(declare-fun |ray_(select old(#length) diff_#in~D.base)| () Int)
(declare-fun
  |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
  () Int)
(declare-fun
  |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
  () Int)
(declare-fun lambda () Int)
(assert
 (and
 (or
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0))
 (and
 (=
 |init_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (= |init_(select #length diff_~B.base)|
 |honda_(select #length diff_~B.base)|)
 (=
 |init_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (= |init_diff_#t~post2| |honda_diff_#t~post2|)
 (= |init_(ite (select #valid diff_~A.base) 1 0)|
 |honda_(ite (select #valid diff_~A.base) 1 0)|)
 (= |init_(select #length diff_~A.base)|
 |honda_(select #length diff_~A.base)|)
 (= |init_(ite (select #valid diff_~B.base) 1 0)|
 |honda_(ite (select #valid diff_~B.base) 1 0)|)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset (- 1)) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| (- 1)) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 (- 1)) 
 (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 1)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 1)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 (- 1)) 
 (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| (- 1))
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 4) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen (- 1))
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| (- 1))
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 1)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 1) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset (- 1)) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 1) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| (- 1))
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset (- 1)) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| (- 1))
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (- 1)) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 1))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 1) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 4)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| (- 1))
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| (- 1))
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 1) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 (- 1)) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 1) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 1)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 1) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 1) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 1) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 1) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 1) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| (- 1)) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 1)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 1)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 1) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| (- 1))
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (- 1)) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 1) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| (- 4))
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 1)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 1) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| (- 1)) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 1) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 1) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 (- 1)) 
 (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 1)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0)
 (* honda_diff_~l2~2 (- 1))
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| (- 1))
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 1)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 4)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| (- 1)) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 1) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 1) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 1) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 1) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~Alen 1)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0)
 (* honda_diff_~l1~2 (- 1)) 
 (* |honda_(select #length diff_#in~B.base)| 0) 
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 0) 0)
 (>=
 (+
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0)
 (*
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)| 0)
 (* |honda_(ite (select #valid diff_#in~D.base) 1 0)| 1)
 (* honda_diff_~Alen 0)
 (* |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)| 0)
 (* honda_diff_~D.offset 0) 
 (* |honda_diff_#in~B.base| 0)
 (* |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)| 0)
 (* honda_diff_~i~2 0) (* honda_diff_~A.base 0) 
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#in~D.offset| 0) 
 (* |honda_(ite (select #valid 0) 1 0)| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(select old(#length) diff_#in~A.base)| 0)
 (* |honda_(ite (select #valid diff_~A.base) 1 0)| 0)
 (* |honda_(select #length diff_~A.base)| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* |honda_diff_#t~post6| 0) 
 (* |honda_#NULL.base| 0) 
 (* honda_diff_~k~2 0) (* honda_diff_~B.offset 0) 
 (* honda_diff_~j~3 0) (* honda_diff_~Blen 0)
 (* |honda_(ite (select #valid diff_#in~A.base) 1 0)| 0)
 (* |honda_diff_#in~D.base| 0) 
 (* |honda_diff_#in~A.offset| 0) 
 (* |honda_diff_#in~Alen| 0)
 (* |honda_(select old(#length) diff_#in~B.base)| 0) 
 (* honda_diff_~l1~2 0) (* |honda_(select #length diff_#in~B.base)| 0)
 (* honda_diff_~found~2 0) 
 (* |honda_(select #length diff_#in~A.base)| 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (* honda_diff_~B.base 0) 
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 0) (* |honda_diff_#in~Blen| 0) 
 (* |honda_diff_#in~B.offset| 0) 
 (* |honda_(select #length diff_~B.base)| 0) 
 (* honda_diff_~D.base 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 0) (* |honda_(select #length diff_#in~D.base)| 0)
 (* |honda_diff_#in~A.base| 0)
 (* |honda_(select old(#length) diff_#in~D.base)| 0) 
 (* honda_diff_~l2~2 0)
 (*
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 0) (* |honda_(ite (select #valid diff_~B.base) 1 0)| 0)
 (* honda_diff_~A.offset 0) 
 (* init_diff_~Blen 0) (* init_diff_~j~3 0) 
 (* init_diff_~B.offset 0) 
 (* |init_diff_#in~D.base| 0) 
 (* |init_diff_#in~A.offset| 0) 
 (* |init_diff_#in~Alen| 0) 
 (* init_diff_~Alen 0) (* init_diff_~l1~2 0) 
 (* init_diff_~D.offset 0) 
 (* |init_diff_#in~B.base| 0) 
 (* init_diff_~found~2 0) 
 (* init_diff_~i~2 0) (* init_diff_~B.base 0) 
 (* init_diff_~A.base 0) (* |init_diff_#in~Blen| 0)
 (* |init_diff_#in~B.offset| 0) 
 (* init_diff_~D.base 0) (* |init_diff_#t~mem0| 0)
 (* |init_diff_#in~A.base| 0) 
 (* |init_diff_#in~D.offset| 0) 
 (* init_diff_~l2~2 0) (* |init_(ite (select #valid 0) 1 0)| 0)
 (* |init_#NULL.offset| 0) 
 (* |init_diff_#t~mem1| 0) 
 (* |init_diff_#t~post6| 0) 
 (* init_diff_~A.offset 0) 
 (* |init_#NULL.base| 0) (* init_diff_~k~2 0) 
 (- 1)) 0)))
 (or
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 4)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 4) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 (- 1))
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 1) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 1)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 (- 1)) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) (- 1))
 (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 1) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 1) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) (- 1)) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 4))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 4)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 4)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 4) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 (- 1))
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) (- 1))
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 1)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) (- 1)) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) (- 1)) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 1)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|))
 (= |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|))
 (= honda_diff_~Alen (+ honda_diff_~Alen ray_diff_~Alen))
 (= |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|))
 (= honda_diff_~D.offset (+ honda_diff_~D.offset ray_diff_~D.offset))
 (= |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|))
 (= |honda_diff_#in~B.base|
 (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|))
 (= honda_diff_~i~2 (+ honda_diff_~i~2 ray_diff_~i~2))
 (= honda_diff_~A.base (+ honda_diff_~A.base ray_diff_~A.base))
 (= |honda_diff_#in~D.offset|
 (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (= |honda_(select old(#length) diff_#in~A.base)|
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|))
 (= |honda_(ite (select #valid diff_~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= |honda_(select #length diff_~A.base)|
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|))
 (= |honda_diff_#t~post6| (+ |honda_diff_#t~post6| |ray_diff_#t~post6|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (= honda_diff_~k~2 (+ honda_diff_~k~2 ray_diff_~k~2))
 (= honda_diff_~B.offset (+ honda_diff_~B.offset ray_diff_~B.offset))
 (= honda_diff_~Blen (+ honda_diff_~Blen ray_diff_~Blen))
 (= |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|))
 (= |honda_diff_#in~D.base|
 (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|))
 (= |honda_diff_#in~A.offset|
 (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|))
 (= |honda_diff_#in~Alen| (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|))
 (= |honda_(select old(#length) diff_#in~B.base)|
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|))
 (= honda_diff_~l1~2 (+ honda_diff_~l1~2 ray_diff_~l1~2))
 (= |honda_(select #length diff_#in~B.base)|
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|))
 (= honda_diff_~found~2 (+ honda_diff_~found~2 ray_diff_~found~2))
 (= |honda_(select #length diff_#in~A.base)|
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|))
 (= honda_diff_~B.base (+ honda_diff_~B.base ray_diff_~B.base))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|))
 (= |honda_diff_#in~Blen| (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|))
 (= |honda_diff_#in~B.offset|
 (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|))
 (= |honda_(select #length diff_~B.base)|
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|))
 (= honda_diff_~D.base (+ honda_diff_~D.base ray_diff_~D.base))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|))
 (= |honda_(select #length diff_#in~D.base)|
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|))
 (= |honda_diff_#in~A.base|
 (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|))
 (= |honda_(select old(#length) diff_#in~D.base)|
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|))
 (=
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|))
 (= honda_diff_~l2~2 (+ honda_diff_~l2~2 ray_diff_~l2~2))
 (= |honda_(ite (select #valid diff_~B.base) 1 0)|
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|))
 (= honda_diff_~A.offset (+ honda_diff_~A.offset ray_diff_~A.offset))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 4)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 1)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) (- 1))
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 1)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) (- 1))
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 1)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 1)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 1)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) (- 1))
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 1)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) (- 4))
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 1)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 1)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1)) (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 1)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 1)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) (- 1))
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 0)
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) (- 1))
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 1)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 0)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 4))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 4)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~B.base) 1 0)|
 |ray_(ite (select #valid diff_#in~B.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~D.base) 1 0)|
 |ray_(ite (select #valid diff_#in~D.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|) 0)
 (* (+ honda_diff_~Alen ray_diff_~Alen) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|) 0)
 (* (+ honda_diff_~D.offset ray_diff_~D.offset) 0)
 (*
 (+ |honda_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~B.base| |ray_diff_#in~B.base|) 0)
 (* (+ honda_diff_~i~2 ray_diff_~i~2) 0)
 (* (+ honda_diff_~A.base ray_diff_~A.base) 0)
 (* (+ |honda_diff_#t~post2| |ray_diff_#t~post2|) 0)
 (* (+ |honda_diff_#t~mem0| |ray_diff_#t~mem0|) 0)
 (* (+ |honda_diff_#in~D.offset| |ray_diff_#in~D.offset|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+ |honda_(select old(#length) diff_#in~A.base)|
 |ray_(select old(#length) diff_#in~A.base)|) 0)
 (*
 (+ |honda_(ite (select #valid diff_~A.base) 1 0)|
 |ray_(ite (select #valid diff_~A.base) 1 0)|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(select #length diff_~A.base)|
 |ray_(select #length diff_~A.base)|) 0)
 (* (+ |honda_diff_#t~mem1| |ray_diff_#t~mem1|) 0)
 (* (+ |honda_diff_#t~post6| |ray_diff_#t~post6|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* (+ honda_diff_~k~2 ray_diff_~k~2) 0)
 (* (+ honda_diff_~B.offset ray_diff_~B.offset) 0)
 (* (+ honda_diff_~j~3 ray_diff_~j~3) 0)
 (* (+ honda_diff_~Blen ray_diff_~Blen) 0)
 (*
 (+ |honda_(ite (select #valid diff_#in~A.base) 1 0)|
 |ray_(ite (select #valid diff_#in~A.base) 1 0)|) 0)
 (* (+ |honda_diff_#in~D.base| |ray_diff_#in~D.base|) 0)
 (* (+ |honda_diff_#in~A.offset| |ray_diff_#in~A.offset|) 0)
 (* (+ |honda_diff_#in~Alen| |ray_diff_#in~Alen|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~B.base)|
 |ray_(select old(#length) diff_#in~B.base)|) 0)
 (* (+ honda_diff_~l1~2 ray_diff_~l1~2) 0)
 (*
 (+ |honda_(select #length diff_#in~B.base)|
 |ray_(select #length diff_#in~B.base)|) 0)
 (* (+ honda_diff_~found~2 ray_diff_~found~2) 0)
 (*
 (+ |honda_(select #length diff_#in~A.base)|
 |ray_(select #length diff_#in~A.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|)
 0) (* (+ honda_diff_~B.base ray_diff_~B.base) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|)
 0) (* (+ |honda_diff_#in~Blen| |ray_diff_#in~Blen|) 0)
 (* (+ |honda_diff_#in~B.offset| |ray_diff_#in~B.offset|) 0)
 (*
 (+ |honda_(select #length diff_~B.base)|
 |ray_(select #length diff_~B.base)|) 0)
 (* (+ honda_diff_~D.base ray_diff_~D.base) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|)
 0)
 (*
 (+ |honda_(select #length diff_#in~D.base)|
 |ray_(select #length diff_#in~D.base)|) 0)
 (* (+ |honda_diff_#in~A.base| |ray_diff_#in~A.base|) 0)
 (*
 (+ |honda_(select old(#length) diff_#in~D.base)|
 |ray_(select old(#length) diff_#in~D.base)|) 0)
 (*
 (+
 |honda_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|)
 0) (* (+ honda_diff_~l2~2 ray_diff_~l2~2) 1)
 (*
 (+ |honda_(ite (select #valid diff_~B.base) 1 0)|
 |ray_(ite (select #valid diff_~B.base) 1 0)|) 0)
 (* (+ honda_diff_~A.offset ray_diff_~A.offset) 0)
 (* |honda_diff_#t~post2| 0) 
 (* |honda_diff_#t~mem0| 0) 
 (* |honda_diff_#t~mem1| 0) 
 (* honda_diff_~j~3 (- 1))
 (*
 |honda_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0) (- 1)) 0)
 (=
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda))
 (= |ray_(ite (select #valid diff_#in~D.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda))
 (= |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda))
 (= ray_diff_~Alen (* ray_diff_~Alen lambda))
 (= |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda))
 (= ray_diff_~D.offset (* ray_diff_~D.offset lambda))
 (= |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)|
 (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda))
 (= |ray_diff_#in~B.base| (* |ray_diff_#in~B.base| lambda))
 (= ray_diff_~i~2 (* ray_diff_~i~2 lambda))
 (= ray_diff_~A.base (* ray_diff_~A.base lambda))
 (= |ray_diff_#in~D.offset| (* |ray_diff_#in~D.offset| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (= |ray_(select old(#length) diff_#in~A.base)|
 (* |ray_(select old(#length) diff_#in~A.base)| lambda))
 (= |ray_(ite (select #valid diff_~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= |ray_(select #length diff_~A.base)|
 (* |ray_(select #length diff_~A.base)| lambda))
 (= |ray_diff_#t~post6| (* |ray_diff_#t~post6| lambda))
 (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (= ray_diff_~k~2 (* ray_diff_~k~2 lambda))
 (= ray_diff_~B.offset (* ray_diff_~B.offset lambda))
 (= ray_diff_~Blen (* ray_diff_~Blen lambda))
 (= |ray_(ite (select #valid diff_#in~A.base) 1 0)|
 (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda))
 (= |ray_diff_#in~D.base| (* |ray_diff_#in~D.base| lambda))
 (= |ray_diff_#in~A.offset| (* |ray_diff_#in~A.offset| lambda))
 (= |ray_diff_#in~Alen| (* |ray_diff_#in~Alen| lambda))
 (= |ray_(select old(#length) diff_#in~B.base)|
 (* |ray_(select old(#length) diff_#in~B.base)| lambda))
 (= ray_diff_~l1~2 (* ray_diff_~l1~2 lambda))
 (= |ray_(select #length diff_#in~B.base)|
 (* |ray_(select #length diff_#in~B.base)| lambda))
 (= ray_diff_~found~2 (* ray_diff_~found~2 lambda))
 (= |ray_(select #length diff_#in~A.base)|
 (* |ray_(select #length diff_#in~A.base)| lambda))
 (= ray_diff_~B.base (* ray_diff_~B.base lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda)) (= |ray_diff_#in~Blen| (* |ray_diff_#in~Blen| lambda))
 (= |ray_diff_#in~B.offset| (* |ray_diff_#in~B.offset| lambda))
 (= |ray_(select #length diff_~B.base)|
 (* |ray_(select #length diff_~B.base)| lambda))
 (= ray_diff_~D.base (* ray_diff_~D.base lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda))
 (= |ray_(select #length diff_#in~D.base)|
 (* |ray_(select #length diff_#in~D.base)| lambda))
 (= |ray_diff_#in~A.base| (* |ray_diff_#in~A.base| lambda))
 (= |ray_(select old(#length) diff_#in~D.base)|
 (* |ray_(select old(#length) diff_#in~D.base)| lambda))
 (=
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda)) (= ray_diff_~l2~2 (* ray_diff_~l2~2 lambda))
 (= |ray_(ite (select #valid diff_~B.base) 1 0)|
 (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda))
 (= ray_diff_~A.offset (* ray_diff_~A.offset lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 4)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 1)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) (- 1)) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 1)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) (- 1))
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 1)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 1)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 1) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) (- 1))
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 1) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) (- 4)) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 1)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 1) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 (- 1))) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 1) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 1) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) (- 1)) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 0)
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) (- 1)) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 1)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 0)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 4))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~B.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* |ray_(ite (select #valid diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~Alen lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~A.base) 1 0)| lambda) 0)
 (* (* ray_diff_~D.offset lambda) 0)
 (* (* |ray_(ite (select old(#valid) diff_#in~D.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~B.base| lambda) 0) 
 (* (* ray_diff_~i~2 lambda) 0) 
 (* (* ray_diff_~A.base lambda) 0) 
 (* (* |ray_diff_#t~post2| lambda) 0) 
 (* (* |ray_diff_#t~mem0| lambda) 0) 
 (* (* |ray_diff_#in~D.offset| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~A.base)| lambda) 0)
 (* (* |ray_(ite (select #valid diff_~A.base) 1 0)| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(select #length diff_~A.base)| lambda) 0)
 (* (* |ray_diff_#t~mem1| lambda) 0) 
 (* (* |ray_diff_#t~post6| lambda) 0) 
 (* (* |ray_#NULL.base| lambda) 0) 
 (* (* ray_diff_~k~2 lambda) 0) 
 (* (* ray_diff_~B.offset lambda) 0) 
 (* (* ray_diff_~j~3 lambda) 0) 
 (* (* ray_diff_~Blen lambda) 0)
 (* (* |ray_(ite (select #valid diff_#in~A.base) 1 0)| lambda) 0)
 (* (* |ray_diff_#in~D.base| lambda) 0)
 (* (* |ray_diff_#in~A.offset| lambda) 0)
 (* (* |ray_diff_#in~Alen| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~l1~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~B.base)| lambda) 0)
 (* (* ray_diff_~found~2 lambda) 0)
 (* (* |ray_(select #length diff_#in~A.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 lambda) 0) (* (* ray_diff_~B.base lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) diff_~B.base) (+ diff_~B.offset (* 4 0)))|
 lambda) 0) (* (* |ray_diff_#in~Blen| lambda) 0)
 (* (* |ray_diff_#in~B.offset| lambda) 0)
 (* (* |ray_(select #length diff_~B.base)| lambda) 0)
 (* (* ray_diff_~D.base lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 diff_~i~2) diff_~A.offset))|
 lambda) 0) (* (* |ray_(select #length diff_#in~D.base)| lambda) 0)
 (* (* |ray_diff_#in~A.base| lambda) 0)
 (* (* |ray_(select old(#length) diff_#in~D.base)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int diff_~A.base) (+ (* 4 0) diff_~A.offset))|
 lambda) 0) (* (* ray_diff_~l2~2 lambda) 1)
 (* (* |ray_(ite (select #valid diff_~B.base) 1 0)| lambda) 0)
 (* (* ray_diff_~A.offset lambda) 0) 
 (* |ray_diff_#t~post2| 0) 
 (* |ray_diff_#t~mem0| 0) 
 (* |ray_diff_#t~mem1| 0) 
 (* ray_diff_~j~3 (- 1))
 (*
 |ray_(select (select #memory_int diff_~B.base) (+ (* 4 diff_~j~3) diff_~B.offset))|
 0)) 0) (= lambda lambda))) 
 (>= lambda 0)))
(check-sat)
(exit)

